ListKong/Controllers/CompanyUserController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    public class CompanyUserController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;
        private readonly UserManager<ApplicationUser> _userManager;

        public CompanyUserController(IConfiguration configuration, UserManager<ApplicationUser> userManager)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
            this._userManager = userManager;
        }
        #endregion
        public IActionResult Index()
        {
            DataTable _dtResponseP = CompanyUserListByUserId();
            if (this._objHelper.checkDBNullResponse(_dtResponseP))
            {
                List<CompanyUserListModel> lst = new List<CompanyUserListModel>();
                lst = ExtensionMethods.DataTableToList<CompanyUserListModel>(_dtResponseP);
                return View(lst);
            }
            
            return View();
        }
        public IActionResult CreateUser()
        {
            var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            CompanyUserModel model = new CompanyUserModel();            
            ViewData["Roles"] = RoleList();
            ViewData["CompanyByAdminUser"] = CompanyList();
            return View(model);
        }
        [HttpPost]
        public IActionResult CreateUser(CompanyUserModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            var user = new ApplicationUser { UserName = model.Email, Email = model.Email,FirstName=model.FirstName,LastName=model.LastName };
            var result = _userManager.CreateAsync(user, model.Password).Result;
            if (result.Succeeded)
            {
                var role = _userManager.AddToRoleAsync(user, model.RoleName).Result;
                var currentUser = _userManager.FindByNameAsync(user.UserName).Result;
                var output = AddUserInCompany(currentUser.Id, model.CompanyId);
                TempData["SuccessMessage"] = "Company user successfully added!";
                return RedirectToAction("Index");
            }
            else
            {
                TempData["ErrorMessage"] = result.Errors.FirstOrDefault().Description;
                return View(model);
            }
        }
        public IActionResult EditCompanyUser(string Id)
        {
            CompanyUserModel model = new CompanyUserModel();
            ViewData["Roles"] = RoleList();
            ViewData["CompanyByAdminUser"] = CompanyList();
            DataTable _dtResponseP = CompanyUserDetailById(Id);
            if (this._objHelper.checkDBNullResponse(_dtResponseP))
            {
                List<CompanyUserModel> lst = new List<CompanyUserModel>();
                lst = ExtensionMethods.DataTableToList<CompanyUserModel>(_dtResponseP);
                return View(lst.FirstOrDefault());
            }
            return View(model);
        }
        [HttpPost]
        public IActionResult EditCompanyUser(CompanyUserModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            ViewData["Roles"] = RoleList();
            ViewData["CompanyByAdminUser"] = CompanyList();

            var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@Id", model.Id));
            parameters.Add(new KeyValuePair<string, string>("@FirstName", model.FirstName));
            parameters.Add(new KeyValuePair<string, string>("@LastName", model.LastName));
            parameters.Add(new KeyValuePair<string, string>("@Email", model.Email));
            parameters.Add(new KeyValuePair<string, string>("@RoleName", model.RoleName));
            parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(model.CompanyId)));
            parameters.Add(new KeyValuePair<string, string>("@UpdatedBy", Convert.ToString(loggedInUserId)));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_User_Detail_Created_By_Admin", parameters);

            return View(model);
        }
        private int AddUserInCompany(string userId,Int64 CompanyId)
        {
            var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@UserId", userId));
            parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(CompanyId)));
            parameters.Add(new KeyValuePair<string, string>("@CreatedBy", Convert.ToString(loggedInUserId)));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Company_User", parameters);
            return 1;
        }

        private DataTable CompanyUserListByUserId()
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            return _objDataHelper.ExecuteProcedure("app_Get_All_User_Created_By_Admin_User", parameters);
        }
        private DataTable CompanyUserDetailById(string userId)
        {
            //var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            return _objDataHelper.ExecuteProcedure("app_Get_User_Detail_Created_By_Admin_By_Id", parameters);
        }
        private DataTable RoleList()
        {
            return _objDataHelper.ExecuteProcedure("app_Get_All_Role_For_Dropdown", null);
        }
        private DataTable CompanyList()
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            return _objDataHelper.ExecuteProcedure("app_Get_Companies_Created_By_Admin_User_Dropdow", parameters);
        }
    }
}

ListKong/Views/CompanyUser/CreateUser.cshtml
@model ListKong.Models.CompanyUserModel
@using  System.Data;
@{
    ViewData["Title"] = "Company User";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="content-wrapper" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">
        <h1>
            Add Company User
        </h1>
        <ol class="breadcrumb">
            <li><a asp-controller="CompnayUser" asp-action="Index"><i class="fa fa-dashboard"></i>Manage Company User</a></li>
            <li class="active">Add Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box box-info">
                    <div class="box-header with-border">
                        <h3 class="box-title">Add Company User</h3>
                    </div>
                    <form asp-action="CreateUser" enctype="multipart/form-data" method="post">
                        <div class="box-body">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>

                            <div class="form-group">
                                <label asp-for="CompanyId" class="control-label"></label>                              
                                <select asp-for="CompanyId" id="CompanyId" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt;
                                        if (ViewData["CompanyByAdminUser"] != null)
                                        {
                                            dt = (DataTable)ViewData["CompanyByAdminUser"];

                                            for (int i = 0; i < dt.Rows.Count; i++)
                                            {
                                                <option value="@dt.Rows[i]["Id"]">@dt.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="CompanyId" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="RoleName" class="control-label"></label>
                                <select asp-for="RoleName" id="RoleName" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt1;
                                        if (ViewData["Roles"] != null)
                                        {
                                            dt1 = (DataTable)ViewData["Roles"];

                                            for (int i = 0; i < dt1.Rows.Count; i++)
                                            {
                                                <option value="@dt1.Rows[i]["Name"]">@dt1.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="RoleName" class="text-danger"></span>
                            </div>

                            <div class="form-group">
                                <label asp-for="FirstName" class="control-label"></label>
                                <input asp-for="FirstName" class="form-control" />
                                <span asp-validation-for="FirstName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LastName" class="control-label"></label>
                                <input asp-for="LastName" class="form-control" />
                                <span asp-validation-for="LastName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Email" class="control-label"></label>
                                <input asp-for="Email" class="form-control" />
                                <span asp-validation-for="Email" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Password" class="control-label"></label>
                                <input asp-for="Password" class="form-control" />
                                <span asp-validation-for="Password" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="ConfirmPassword"></label>
                                <input asp-for="ConfirmPassword" class="form-control" />
                                <span asp-validation-for="ConfirmPassword" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <input type="submit" value="Create Company User" class="btn btn-primary" />
                            </div>
                        </div>
                    </form>
                    <div>
                        <a asp-action="Index">Back to List</a>
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>


@section Scripts {
    <partial name="_ValidationScriptsPartial" />
}

ListKong/Views/CompanyUser/EditCompanyUser.cshtml
@model ListKong.Models.CompanyUserModel
@using  System.Data;
@{
    ViewData["Title"] = "Company User";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="content-wrapper" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">
        <h1>
            View Company User
        </h1>
        <ol class="breadcrumb">
            <li><a asp-controller="CompnayUser" asp-action="Index"><i class="fa fa-dashboard"></i>Manage Company User</a></li>
            <li class="active">View Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box box-info">
                    <div class="box-header with-border">
                        <h3 class="box-title">View Company User</h3>
                    </div>
                    <form asp-action="EditCompanyUser" enctype="multipart/form-data" method="post">
                        <div class="box-body">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>

                            <input type="hidden" asp-for="Id" class="form-control" />
                            <div class="form-group">
                                <label asp-for="CompanyId" class="control-label"></label>
                                <select asp-for="CompanyId" id="CompanyId" class="form-control" disabled>
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt;
                                        if (ViewData["CompanyByAdminUser"] != null)
                                        {
                                            dt = (DataTable)ViewData["CompanyByAdminUser"];

                                            for (int i = 0; i < dt.Rows.Count; i++)
                                            {
                                                <option value="@dt.Rows[i]["Id"]">@dt.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="CompanyId" class="text-danger"></span>
                            </div>
                            
                            <div class="form-group">
                                <label asp-for="RoleName" class="control-label"></label>
                                <select asp-for="RoleName" id="RoleName" class="form-control" disabled>
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt1;
                                        if (ViewData["Roles"] != null)
                                        {
                                            dt1 = (DataTable)ViewData["Roles"];

                                            for (int i = 0; i < dt1.Rows.Count; i++)
                                            {
                                                <option value="@dt1.Rows[i]["Name"]">@dt1.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="RoleName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="FirstName" class="control-label"></label>
                                <input asp-for="FirstName" class="form-control" disabled/>
                                <span asp-validation-for="FirstName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LastName" class="control-label"></label>
                                <input asp-for="LastName" class="form-control" disabled/>
                                <span asp-validation-for="LastName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Email" class="control-label"></label>
                                <input asp-for="Email" class="form-control" disabled />
                                <span asp-validation-for="Email" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                @*<input type="submit" value="Update Company User" class="btn btn-primary" />*@
                            </div>
                        </div>
                    </form>
                    <div>
                        <a asp-action="Index">Back to List</a>
                    </div>
                </div>
            </div>
        </div>
    </section>
</div>


@section Scripts {
    <partial name="_ValidationScriptsPartial" />
}

ListKong/Views/CompanyUser/Index.cshtml
@model IEnumerable<CompanyUserListModel>

@{
    ViewData["Title"] = "Manage Company User";
}

<div class="content-wrapper" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">
        <h1>
            Manage Company User
        </h1>
        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
            <li class="active">Manage Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="box">
                    <div class="box-header">
                        <h3 class="box-title"></h3>
                        <div class="box-tools">
                            <div class="input-group input-group-sm" style="width: 150px;text-align:right;">
                                <a asp-controller="CompanyUser" asp-action="CreateUser"><i class="fa fa-plus-circle"></i><span>Add New</span></a>
                            </div>
                        </div>
                    </div>
                    <!-- /.box-header -->
                    <div class="box-body table-responsive">
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["ErrorMessage"])))
                        {
                            <div class="alert alert-danger">  @TempData["ErrorMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["SuccessMessage"])))
                        {
                            <div class="alert alert-success">  @TempData["SuccessMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                   
                                    <th>
                                        @Html.DisplayNameFor(model => model.CompanyName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.RoleName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.FirstName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.LastName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.Email)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.CreatedOn)
                                    </th>

                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var item in Model)
                                {
                                <tr>
                                    
                                    <td>
                                        @Html.DisplayFor(modelItem => item.CompanyName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.RoleName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.FirstName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.LastName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Email)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.CreatedOn)
                                    </td>
                                    <td>
                                        <a asp-action="EditCompanyUser" asp-route-id="@item.Id" class="fa fa-street-view" title="View Company User"></a>

                                    </td>
                                </tr>
                                }
                            </tbody>
                        </table>
                    </div>
                </div>
                <div>
                    @*<a asp-action="Index">Back to List</a>*@
                </div>
                <!-- /.box -->
            </div>
        </div>
    </section>
</div>